"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var jumblator_encryption_1 = require("./jumblator-encryption");
var log_1 = require("./log");
;
exports.lastModifiedPlugin = function (schema, options) {
    var _a, _b, _c, _d, _e;
    var keySize = (_a = options.keySize) !== null && _a !== void 0 ? _a : 256;
    var keySalt = (_b = options.keySalt) !== null && _b !== void 0 ? _b : 'keySalt';
    var seed = (_c = options.seed) !== null && _c !== void 0 ? _c : 'seed';
    var encoding = (_d = options.encoding) !== null && _d !== void 0 ? _d : 'Hex';
    var length = (_e = options.length) !== null && _e !== void 0 ? _e : 512;
    var secret = options.secret;
    var providedOptions = {
        keySize: keySize,
        keySalt: keySalt,
        seed: seed,
        encoding: encoding,
        length: length,
        secret: secret
    };
    var pathsToEncrypt = [];
    var pathsToHash = [];
    schema.eachPath(function (pathName, schemaType) {
        if (schemaType.options && schemaType.options.encrypt) {
            pathsToEncrypt.push(pathName);
        }
    });
    schema.eachPath(function (pathName, schemaType) {
        if (schemaType.options && schemaType.options.searchable) {
            pathsToHash.push(pathName);
        }
    });
    pathsToEncrypt.forEach(function (path) {
        var _a;
        var newPath = '__' + path + '_enc';
        schema.add((_a = {}, _a[newPath] = String, _a));
    });
    pathsToHash.forEach(function (path) {
        var _a;
        var newPath = '__' + path + '_hash';
        schema.add((_a = {}, _a[newPath] = String, _a));
    });
    function updateHandler() {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, updates, i, newPath, hash, j, newPath, enc, newPathHash, hash;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        conditions = this._conditions;
                        updates = this._update;
                        for (i = 0; i < pathsToHash.length; i++) {
                            if (Object.keys(conditions).includes(pathsToHash[i])) {
                                newPath = '__' + pathsToHash[i] + '_hash';
                                hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                                this.where((_a = {}, _a[newPath] = hash, _a));
                                delete conditions[pathsToHash[i]];
                            }
                        }
                        j = 0;
                        _c.label = 1;
                    case 1:
                        if (!(j < pathsToEncrypt.length)) return [3 /*break*/, 4];
                        if (!Object.keys(updates).includes(pathsToEncrypt[j])) return [3 /*break*/, 3];
                        newPath = '__' + pathsToEncrypt[j] + '_enc';
                        return [4 /*yield*/, jumblator_encryption_1.encryptField(updates[pathsToEncrypt[j]], options.secret, providedOptions)];
                    case 2:
                        enc = _c.sent();
                        newPathHash = '__' + pathsToEncrypt[j] + '_hash';
                        hash = jumblator_encryption_1.generateSearchHash(updates[pathsToEncrypt[j]]);
                        this.update({}, (_b = {}, _b[newPath] = enc, _b[newPathHash] = hash, _b));
                        delete updates[pathsToEncrypt[j]];
                        log_1.log.debug('updates', updates);
                        log_1.log.debug('conditions', conditions);
                        _c.label = 3;
                    case 3:
                        j++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    schema.pre('save', function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var j, hash, hashPath, i, enc, encPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        for (j = 0; j < pathsToHash.length; j++) {
                            hash = jumblator_encryption_1.generateSearchHash(this[pathsToHash[j]]);
                            hashPath = '__' + pathsToHash[j] + '_hash';
                            this[hashPath] = hash;
                        }
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < pathsToEncrypt.length)) return [3 /*break*/, 4];
                        return [4 /*yield*/, jumblator_encryption_1.encryptField(this[pathsToEncrypt[i]], options.secret, providedOptions)];
                    case 2:
                        enc = _a.sent();
                        encPath = '__' + pathsToEncrypt[i] + '_enc';
                        this[encPath] = enc;
                        this[pathsToEncrypt[i]] = undefined;
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        next();
                        return [2 /*return*/];
                }
            });
        });
    });
    schema.pre('findOne', function () {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, i, newPath, hash;
            var _a;
            return __generator(this, function (_b) {
                conditions = this.find()._conditions;
                for (i = 0; i < pathsToHash.length; i++) {
                    if (Object.keys(conditions).includes(pathsToHash[i])) {
                        newPath = '__' + pathsToHash[i] + '_hash';
                        log_1.log.debug(conditions[pathsToHash[i]]);
                        hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                        log_1.log.debug(hash);
                        delete conditions[pathsToHash[i]];
                        this.where((_a = {}, _a[newPath] = hash, _a));
                        log_1.log.debug(conditions);
                    }
                }
                return [2 /*return*/];
            });
        });
    });
    schema.pre('find', function () {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, i, newPath, hash;
            var _a;
            return __generator(this, function (_b) {
                conditions = this.find()._conditions;
                for (i = 0; i < pathsToHash.length; i++) {
                    if (Object.keys(conditions).includes(pathsToHash[i])) {
                        newPath = '__' + pathsToHash[i] + '_hash';
                        log_1.log.debug(conditions[pathsToHash[i]]);
                        hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                        log_1.log.debug(hash);
                        delete conditions[pathsToHash[i]];
                        this.where((_a = {}, _a[newPath] = hash, _a));
                        log_1.log.debug(conditions);
                    }
                }
                return [2 /*return*/];
            });
        });
    });
    schema.post('findOne', function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var keys, key, i, originalKey, dec, hashKey;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        keys = [];
                        for (key in next) {
                            if (/^__[A-Za-z]+_enc/.test(key)) {
                                keys.push(key);
                            }
                        }
                        log_1.log.debug('keys', keys);
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < keys.length)) return [3 /*break*/, 4];
                        originalKey = keys[i].split('_')[2];
                        return [4 /*yield*/, jumblator_encryption_1.decryptField(next[keys[i]], options.secret, providedOptions)];
                    case 2:
                        dec = _a.sent();
                        next[originalKey] = dec;
                        next[keys[i]] = undefined;
                        hashKey = '__' + originalKey + '_hash';
                        delete next[hashKey];
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    });
    schema.post('find', function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var j, keys, key, i, originalKey, dec, hashKey;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        j = 0;
                        _a.label = 1;
                    case 1:
                        if (!(j < next.length)) return [3 /*break*/, 6];
                        keys = [];
                        for (key in next[j]) {
                            if (/^__[A-Za-z]+_enc/.test(key)) {
                                keys.push(key);
                            }
                        }
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < keys.length)) return [3 /*break*/, 5];
                        originalKey = keys[i].split('_')[2];
                        return [4 /*yield*/, jumblator_encryption_1.decryptField(next[j][keys[i]], options.secret, providedOptions)];
                    case 3:
                        dec = _a.sent();
                        next[j][originalKey] = dec;
                        next[j][keys[i]] = undefined;
                        hashKey = '__' + originalKey + '_hash';
                        next[j][hashKey] = undefined;
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5:
                        j++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    });
    schema.pre('findOneAndUpdate', updateHandler);
    schema.pre('updateOne', updateHandler);
    schema.pre('update', updateHandler);
    schema.pre('updateMany', updateHandler);
};
exports.default = exports.lastModifiedPlugin;
